-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Charts - Winloss Sparklines
This demo illustrates the sparklines of the win-loss type. In the winloss sparkline, values are represented by bars that either grow up or go down from an invisible line. This line is determined by a threshold value. If a data source value is greater than this threshold value, the bar grows up. Otherwise, it goes down.
Backend API
$(() => {
const copperOptions = {
dataSource: copperCosts,
argumentField: 'month',
valueField: '2021',
type: 'winloss',
showMinMax: true,
winlossThreshold: 8000,
tooltip: {
format: {
type: 'currency',
precision: 2,
},
},
};
const nickelOptions = {
dataSource: nickelCosts,
argumentField: 'month',
valueField: '2021',
type: 'winloss',
showMinMax: true,
showFirstLast: false,
winColor: '#6babac',
lossColor: '#8076bb',
winlossThreshold: 19000,
tooltip: {
format: {
type: 'currency',
precision: 2,
},
},
};
const palladiumOptions = {
dataSource: palladiumCosts,
argumentField: 'month',
valueField: '2021',
type: 'winloss',
winlossThreshold: 2000,
winColor: '#7e4452',
lossColor: '#ebdd8f',
firstLastColor: '#e55253',
tooltip: {
format: {
type: 'currency',
precision: 2,
},
},
};
$('.copper2021').dxSparkline(copperOptions);
$('.nickel2021').dxSparkline(nickelOptions);
$('.palladium2021').dxSparkline(palladiumOptions);
$('.copper2022').dxSparkline($.extend(copperOptions, { valueField: '2022' }));
$('.nickel2022').dxSparkline($.extend(nickelOptions, { valueField: '2022' }));
$('.palladium2022').dxSparkline($.extend(palladiumOptions, { valueField: '2022' }));
$('.copper2023').dxSparkline($.extend(copperOptions, { valueField: '2023' }));
$('.nickel2023').dxSparkline($.extend(nickelOptions, { valueField: '2023' }));
$('.palladium2023').dxSparkline($.extend(palladiumOptions, { valueField: '2023' }));
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="long-title"><h3>Monthly Prices of Copper, Nickel and Palladium</h3></div>
<div id="chart-demo">
<table class="demo-table" border="1">
<tr>
<th><div class="dx-screen-reader-only">Year</div></th>
<th>Copper (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Palladium (USD/troy ounce)</th>
</tr>
<tr>
<th>2021</th>
<td><div class="sparkline copper2021"></div></td>
<td><div class="sparkline nickel2021"></div></td>
<td><div class="sparkline palladium2021"></div></td>
</tr>
<tr>
<th>2022</th>
<td><div class="sparkline copper2022"></div></td>
<td><div class="sparkline nickel2022"></div></td>
<td><div class="sparkline palladium2022"></div></td>
</tr>
<tr>
<th>2023</th>
<td><div class="sparkline copper2023"></div></td>
<td><div class="sparkline nickel2023"></div></td>
<td><div class="sparkline palladium2023"></div></td>
</tr>
</table>
</div>
</div>
</body>
</html>
#chart-demo {
height: 440px;
}
.demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th,
.demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
.demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
.demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.demo-table .sparkline {
width: 200px;
height: 30px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}
const copperCosts = [{
month: 1,
2021: 7970.50,
2022: 9775.93,
2023: 8999.79,
}, {
month: 2,
2021: 8460.25,
2022: 9941.35,
2023: 8955.20,
}, {
month: 3,
2021: 9004.98,
2022: 10237.59,
2023: 8835.72,
}, {
month: 4,
2021: 9335.55,
2022: 10183.13,
2023: 8814.00,
}, {
month: 5,
2021: 10183.97,
2022: 9362.81,
2023: 8234.28,
}, {
month: 6,
2021: 9612.43,
2022: 9033.13,
2023: 8386.23,
}, {
month: 7,
2021: 9433.59,
2022: 7529.79,
2023: 8445.26,
}, {
month: 8,
2021: 9357.19,
2022: 7960.98,
2023: 8351.77,
}, {
month: 9,
2021: 9324.07,
2022: 7734.70,
2023: 8270.86,
}, {
month: 10,
2021: 9778.50,
2022: 7621.21,
2023: 7939.66,
}, {
month: 11,
2021: 9765.48,
2022: 8029.95,
2023: 8173.95,
}, {
month: 12,
2021: 9550.31,
2022: 8367.23,
2023: 8394.11,
}];
const nickelCosts = [{
month: 1,
2021: 17847.68,
2022: 22355.40,
2023: 28194.61,
}, {
month: 2,
2021: 18595.30,
2022: 24015.55,
2023: 26727.95,
}, {
month: 3,
2021: 16460.83,
2022: 33924.18,
2023: 23288.61,
}, {
month: 4,
2021: 16480.91,
2022: 33132.74,
2023: 23894.56,
}, {
month: 5,
2021: 17552.45,
2022: 28062.55,
2023: 21970.39,
}, {
month: 6,
2021: 17942.32,
2022: 25658.63,
2023: 21233.28,
}, {
month: 7,
2021: 18819.36,
2022: 21481.89,
2023: 21091.26,
}, {
month: 8,
2021: 19160.23,
2022: 22057.39,
2023: 20438.65,
}, {
month: 9,
2021: 19398.23,
2022: 22773.97,
2023: 19644.64,
}, {
month: 10,
2021: 19420.52,
2022: 22032.89,
2023: 18281.23,
}, {
month: 11,
2021: 19970.43,
2022: 25562.70,
2023: 17027.36,
}, {
month: 12,
2021: 20015.55,
2022: 28946.81,
2023: 16460.84,
}];
const palladiumCosts = [{
month: 1,
2021: 2391.20,
2022: 2030.86,
2023: 1734.27,
}, {
month: 2,
2021: 2342.33,
2022: 2350.10,
2023: 1543.90,
}, {
month: 3,
2021: 2525.61,
2022: 2582.78,
2023: 1426.00,
}, {
month: 4,
2021: 2776.45,
2022: 2330.67,
2023: 1508.00,
}, {
month: 5,
2021: 2900.52,
2022: 2060.05,
2023: 1482.61,
}, {
month: 6,
2021: 2752.48,
2022: 1913.05,
2023: 1348.09,
}, {
month: 7,
2021: 2754.76,
2022: 1973.10,
2023: 1264.48,
}, {
month: 8,
2021: 2544.73,
2022: 2135.52,
2023: 1247.30,
}, {
month: 9,
2021: 2130.32,
2022: 2113.95,
2023: 1239.29,
}, {
month: 10,
2021: 2058.48,
2022: 2078.86,
2023: 1142.09,
}, {
month: 11,
2021: 2036.32,
2022: 1911.55,
2023: 1050.27,
}, {
month: 12,
2021: 1810.52,
2022: 1808.36,
2023: 1087.76,
}];

Backend API
<div class="long-title"
><h3>Monthly Prices of Aluminium, Nickel and Copper</h3></div
>
<div id="chart-demo">
<table class="demo-table">
<tr>
<th></th>
<th>Aluminium (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Copper (USD/ton)</th>
</tr>
<tr *ngFor="let year of years">
<th>{{ year }}</th>
<td>
<dx-sparkline
class="sparkline"
[dataSource]="aluminumCosts"
argumentField="month"
valueField="{{ year }}"
type="winloss"
[showMinMax]="true"
[winlossThreshold]="2100"
>
<dxo-tooltip format="currency"></dxo-tooltip>
</dx-sparkline>
</td>
<td>
<dx-sparkline
class="sparkline"
[dataSource]="nickelCosts"
argumentField="month"
valueField="{{ year }}"
type="winloss"
[showMinMax]="true"
[showFirstLast]="false"
winColor="#6babac"
lossColor="#8076bb"
[winlossThreshold]="19000"
>
<dxo-tooltip format="currency"></dxo-tooltip>
</dx-sparkline>
</td>
<td>
<dx-sparkline
class="sparkline"
[dataSource]="cooperCosts"
argumentField="month"
valueField="{{ year }}"
type="winloss"
winColor="#7e4452"
lossColor="#ebdd8f"
firstLastColor="#e55253"
[winlossThreshold]="8000"
>
<dxo-tooltip format="currency"></dxo-tooltip>
</dx-sparkline>
</td>
</tr>
</table>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxSparklineModule } from 'devextreme-angular';
import { CostInfo, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
})
export class AppComponent {
aluminumCosts: CostInfo[];
nickelCosts: CostInfo[];
cooperCosts: CostInfo[];
years: Array<number>;
constructor(service: Service) {
this.aluminumCosts = service.getAluminumCosts();
this.nickelCosts = service.getNickelCosts();
this.cooperCosts = service.getCooperCosts();
this.years = [2010, 2011, 2012];
}
}
@NgModule({
imports: [
BrowserModule,
DxSparklineModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #chart-demo {
height: 440px;
}
::ng-deep .demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
::ng-deep .demo-table th,
::ng-deep .demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
::ng-deep .demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
::ng-deep .demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
::ng-deep .demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
::ng-deep .demo-table .sparkline {
width: 200px;
height: 30px;
}
::ng-deep .long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}
import { Injectable } from '@angular/core';
export class CostInfo {
month: number;
2010: number;
2011: number;
2012: number;
}
const aluminumCosts: CostInfo[] = [{
month: 1,
2010: 2262,
2011: 2454,
2012: 2262,
}, {
month: 2,
2010: 2087,
2011: 2537,
2012: 2087,
}, {
month: 3,
2010: 2238,
2011: 2586,
2012: 2238,
}, {
month: 4,
2010: 2349,
2011: 2689,
2012: 2349,
}, {
month: 5,
2010: 2071,
2011: 2591,
2012: 2071,
}, {
month: 6,
2010: 1957,
2011: 2584,
2012: 1957,
}, {
month: 7,
2010: 2008,
2011: 2554,
2012: 2008,
}, {
month: 8,
2010: 2119,
2011: 2413,
2012: 2119,
}, {
month: 9,
2010: 2199,
2011: 2327,
2012: 2199,
}, {
month: 10,
2010: 2374,
2011: 2210,
2012: 2374,
}, {
month: 11,
2010: 2354,
2011: 2102,
2012: 2354,
}, {
month: 12,
2010: 2369,
2011: 2038,
2012: 2369,
}];
const nickelCosts: CostInfo[] = [{
month: 1,
2010: 18974,
2011: 24298,
2012: 18322,
}, {
month: 2,
2010: 18162,
2011: 27929,
2012: 21093,
}, {
month: 3,
2010: 20535,
2011: 28802,
2012: 19701,
}, {
month: 4,
2010: 24562,
2011: 26142,
2012: 17695,
}, {
month: 5,
2010: 26131,
2011: 26753,
2012: 17549,
}, {
month: 6,
2010: 19278,
2011: 23055,
2012: 16436,
}, {
month: 7,
2010: 19475,
2011: 22870,
2012: 16382,
}, {
month: 8,
2010: 20701,
2011: 24388,
2012: 15687,
}, {
month: 9,
2010: 21266,
2011: 21845,
2012: 16085,
}, {
month: 10,
2010: 23358,
2011: 18346,
2012: 18250,
}, {
month: 11,
2010: 23150,
2011: 18822,
2012: 16083,
}, {
month: 12,
2010: 23282,
2011: 17320,
2012: 17104,
}];
const copperCosts: CostInfo[] = [{
month: 1,
2010: 7341,
2011: 9585,
2012: 7501,
}, {
month: 2,
2010: 7016,
2011: 10026,
2012: 8470,
}, {
month: 3,
2010: 7202,
2011: 9889,
2012: 8591,
}, {
month: 4,
2010: 7851,
2011: 9460,
2012: 8459,
}, {
month: 5,
2010: 7481,
2011: 9373,
2012: 8320,
}, {
month: 6,
2010: 6532,
2011: 9108,
2012: 7465,
}, {
month: 7,
2010: 6498,
2011: 9295,
2012: 7475,
}, {
month: 8,
2010: 7191,
2011: 9834,
2012: 7430,
}, {
month: 9,
2010: 7596,
2011: 9121,
2012: 7614,
}, {
month: 10,
2010: 8057,
2011: 7125,
2012: 8245,
}, {
month: 11,
2010: 8373,
2011: 7871,
2012: 7727,
}, {
month: 12,
2010: 8636,
2011: 7725,
2012: 7880,
}];
@Injectable()
export class Service {
getAluminumCosts(): CostInfo[] {
return aluminumCosts;
}
getNickelCosts(): CostInfo[] {
return nickelCosts;
}
getCooperCosts(): CostInfo[] {
return copperCosts;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "17.3.12"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.4.5"
},
"zone.js": {
"version": "0.14.10"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
import React from 'react';
import RowTemplate from './RowTemplate.tsx';
const years = ['2021', '2022', '2023'];
function App() {
return (
<>
<div className="long-title"><h3>Monthly Prices of Copper, Nickel and Palladium</h3></div>
<div id="chart-demo">
<table
className="demo-table"
style={{ border: 1 }}
>
<tbody>
<tr>
<th><div className="dx-screen-reader-only">Year</div></th>
<th>Copper (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Palladium (USD/troy ounce)</th>
</tr>
{
years.map((year, index) => <RowTemplate key={index} year={year} />)
}
</tbody>
</table>
</div>
</>
);
}
export default App;
import React from 'react';
import RowTemplate from './RowTemplate.js';
const years = ['2021', '2022', '2023'];
function App() {
return (
<>
<div className="long-title">
<h3>Monthly Prices of Copper, Nickel and Palladium</h3>
</div>
<div id="chart-demo">
<table
className="demo-table"
style={{ border: 1 }}
>
<tbody>
<tr>
<th>
<div className="dx-screen-reader-only">Year</div>
</th>
<th>Copper (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Palladium (USD/troy ounce)</th>
</tr>
{years.map((year, index) => (
<RowTemplate
key={index}
year={year}
/>
))}
</tbody>
</table>
</div>
</>
);
}
export default App;
import React from 'react';
import Sparkline, {
Tooltip,
} from 'devextreme-react/sparkline';
import {
copperCosts,
nickelCosts,
palladiumCosts,
} from './data.ts';
interface RowTemplateProps {
key: number;
year: string;
}
export default function RowTemplate(props: RowTemplateProps) {
return (
<tr>
<th>{ props.year }</th>
<td>
<Sparkline
dataSource={copperCosts}
showMinMax={true}
winlossThreshold={8000}
className="sparkline"
argumentField="month"
valueField={props.year}
type="winloss"
>
<Tooltip format={{ type: 'currency', precision: 2 }} />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={nickelCosts}
showMinMax={true}
showFirstLast={false}
winlossThreshold={19000}
className="sparkline"
argumentField="month"
valueField={props.year}
type="winloss"
winColor="#6babac"
lossColor="#8076bb"
>
<Tooltip format={{ type: 'currency', precision: 2 }} />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={palladiumCosts}
winlossThreshold={2000}
className="sparkline"
argumentField="month"
valueField={props.year}
type="winloss"
firstLastColor="#e55253"
winColor="#7e4452"
lossColor="#ebdd8f"
>
<Tooltip format={{ type: 'currency', precision: 2 }} />
</Sparkline>
</td>
</tr>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const copperCosts = [{
month: 1,
2021: 7970.50,
2022: 9775.93,
2023: 8999.79,
}, {
month: 2,
2021: 8460.25,
2022: 9941.35,
2023: 8955.20,
}, {
month: 3,
2021: 9004.98,
2022: 10237.59,
2023: 8835.72,
}, {
month: 4,
2021: 9335.55,
2022: 10183.13,
2023: 8814.00,
}, {
month: 5,
2021: 10183.97,
2022: 9362.81,
2023: 8234.28,
}, {
month: 6,
2021: 9612.43,
2022: 9033.13,
2023: 8386.23,
}, {
month: 7,
2021: 9433.59,
2022: 7529.79,
2023: 8445.26,
}, {
month: 8,
2021: 9357.19,
2022: 7960.98,
2023: 8351.77,
}, {
month: 9,
2021: 9324.07,
2022: 7734.70,
2023: 8270.86,
}, {
month: 10,
2021: 9778.50,
2022: 7621.21,
2023: 7939.66,
}, {
month: 11,
2021: 9765.48,
2022: 8029.95,
2023: 8173.95,
}, {
month: 12,
2021: 9550.31,
2022: 8367.23,
2023: 8394.11,
}];
export const nickelCosts = [{
month: 1,
2021: 17847.68,
2022: 22355.40,
2023: 28194.61,
}, {
month: 2,
2021: 18595.30,
2022: 24015.55,
2023: 26727.95,
}, {
month: 3,
2021: 16460.83,
2022: 33924.18,
2023: 23288.61,
}, {
month: 4,
2021: 16480.91,
2022: 33132.74,
2023: 23894.56,
}, {
month: 5,
2021: 17552.45,
2022: 28062.55,
2023: 21970.39,
}, {
month: 6,
2021: 17942.32,
2022: 25658.63,
2023: 21233.28,
}, {
month: 7,
2021: 18819.36,
2022: 21481.89,
2023: 21091.26,
}, {
month: 8,
2021: 19160.23,
2022: 22057.39,
2023: 20438.65,
}, {
month: 9,
2021: 19398.23,
2022: 22773.97,
2023: 19644.64,
}, {
month: 10,
2021: 19420.52,
2022: 22032.89,
2023: 18281.23,
}, {
month: 11,
2021: 19970.43,
2022: 25562.70,
2023: 17027.36,
}, {
month: 12,
2021: 20015.55,
2022: 28946.81,
2023: 16460.84,
}];
export const palladiumCosts = [{
month: 1,
2021: 2391.20,
2022: 2030.86,
2023: 1734.27,
}, {
month: 2,
2021: 2342.33,
2022: 2350.10,
2023: 1543.90,
}, {
month: 3,
2021: 2525.61,
2022: 2582.78,
2023: 1426.00,
}, {
month: 4,
2021: 2776.45,
2022: 2330.67,
2023: 1508.00,
}, {
month: 5,
2021: 2900.52,
2022: 2060.05,
2023: 1482.61,
}, {
month: 6,
2021: 2752.48,
2022: 1913.05,
2023: 1348.09,
}, {
month: 7,
2021: 2754.76,
2022: 1973.10,
2023: 1264.48,
}, {
month: 8,
2021: 2544.73,
2022: 2135.52,
2023: 1247.30,
}, {
month: 9,
2021: 2130.32,
2022: 2113.95,
2023: 1239.29,
}, {
month: 10,
2021: 2058.48,
2022: 2078.86,
2023: 1142.09,
}, {
month: 11,
2021: 2036.32,
2022: 1911.55,
2023: 1050.27,
}, {
month: 12,
2021: 1810.52,
2022: 1808.36,
2023: 1087.76,
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import Sparkline, { Tooltip } from 'devextreme-react/sparkline';
import { copperCosts, nickelCosts, palladiumCosts } from './data.js';
export default function RowTemplate(props) {
return (
<tr>
<th>{props.year}</th>
<td>
<Sparkline
dataSource={copperCosts}
showMinMax={true}
winlossThreshold={8000}
className="sparkline"
argumentField="month"
valueField={props.year}
type="winloss"
>
<Tooltip format={{ type: 'currency', precision: 2 }} />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={nickelCosts}
showMinMax={true}
showFirstLast={false}
winlossThreshold={19000}
className="sparkline"
argumentField="month"
valueField={props.year}
type="winloss"
winColor="#6babac"
lossColor="#8076bb"
>
<Tooltip format={{ type: 'currency', precision: 2 }} />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={palladiumCosts}
winlossThreshold={2000}
className="sparkline"
argumentField="month"
valueField={props.year}
type="winloss"
firstLastColor="#e55253"
winColor="#7e4452"
lossColor="#ebdd8f"
>
<Tooltip format={{ type: 'currency', precision: 2 }} />
</Sparkline>
</td>
</tr>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const copperCosts = [
{
month: 1,
2021: 7970.5,
2022: 9775.93,
2023: 8999.79,
},
{
month: 2,
2021: 8460.25,
2022: 9941.35,
2023: 8955.2,
},
{
month: 3,
2021: 9004.98,
2022: 10237.59,
2023: 8835.72,
},
{
month: 4,
2021: 9335.55,
2022: 10183.13,
2023: 8814.0,
},
{
month: 5,
2021: 10183.97,
2022: 9362.81,
2023: 8234.28,
},
{
month: 6,
2021: 9612.43,
2022: 9033.13,
2023: 8386.23,
},
{
month: 7,
2021: 9433.59,
2022: 7529.79,
2023: 8445.26,
},
{
month: 8,
2021: 9357.19,
2022: 7960.98,
2023: 8351.77,
},
{
month: 9,
2021: 9324.07,
2022: 7734.7,
2023: 8270.86,
},
{
month: 10,
2021: 9778.5,
2022: 7621.21,
2023: 7939.66,
},
{
month: 11,
2021: 9765.48,
2022: 8029.95,
2023: 8173.95,
},
{
month: 12,
2021: 9550.31,
2022: 8367.23,
2023: 8394.11,
},
];
export const nickelCosts = [
{
month: 1,
2021: 17847.68,
2022: 22355.4,
2023: 28194.61,
},
{
month: 2,
2021: 18595.3,
2022: 24015.55,
2023: 26727.95,
},
{
month: 3,
2021: 16460.83,
2022: 33924.18,
2023: 23288.61,
},
{
month: 4,
2021: 16480.91,
2022: 33132.74,
2023: 23894.56,
},
{
month: 5,
2021: 17552.45,
2022: 28062.55,
2023: 21970.39,
},
{
month: 6,
2021: 17942.32,
2022: 25658.63,
2023: 21233.28,
},
{
month: 7,
2021: 18819.36,
2022: 21481.89,
2023: 21091.26,
},
{
month: 8,
2021: 19160.23,
2022: 22057.39,
2023: 20438.65,
},
{
month: 9,
2021: 19398.23,
2022: 22773.97,
2023: 19644.64,
},
{
month: 10,
2021: 19420.52,
2022: 22032.89,
2023: 18281.23,
},
{
month: 11,
2021: 19970.43,
2022: 25562.7,
2023: 17027.36,
},
{
month: 12,
2021: 20015.55,
2022: 28946.81,
2023: 16460.84,
},
];
export const palladiumCosts = [
{
month: 1,
2021: 2391.2,
2022: 2030.86,
2023: 1734.27,
},
{
month: 2,
2021: 2342.33,
2022: 2350.1,
2023: 1543.9,
},
{
month: 3,
2021: 2525.61,
2022: 2582.78,
2023: 1426.0,
},
{
month: 4,
2021: 2776.45,
2022: 2330.67,
2023: 1508.0,
},
{
month: 5,
2021: 2900.52,
2022: 2060.05,
2023: 1482.61,
},
{
month: 6,
2021: 2752.48,
2022: 1913.05,
2023: 1348.09,
},
{
month: 7,
2021: 2754.76,
2022: 1973.1,
2023: 1264.48,
},
{
month: 8,
2021: 2544.73,
2022: 2135.52,
2023: 1247.3,
},
{
month: 9,
2021: 2130.32,
2022: 2113.95,
2023: 1239.29,
},
{
month: 10,
2021: 2058.48,
2022: 2078.86,
2023: 1142.09,
},
{
month: 11,
2021: 2036.32,
2022: 1911.55,
2023: 1050.27,
},
{
month: 12,
2021: 1810.52,
2022: 1808.36,
2023: 1087.76,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart-demo {
height: 440px;
}
.demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th,
.demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
.demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
.demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.demo-table .sparkline {
width: 200px;
height: 30px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}

Backend API
<template>
<div>
<div class="long-title"><h3>Monthly Prices of Copper, Nickel and Palladium</h3></div>
<div id="chart-demo">
<table
class="demo-table"
border="1"
>
<tr>
<th><div class="dx-screen-reader-only">Year</div></th>
<th>Copper (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Palladium (USD/troy ounce)</th>
</tr>
<tbody
v-for="(year, index) in years"
:key="index"
>
<RowTemplate :year="year"/>
</tbody>
</table>
</div>
</div>
</template>
<script setup lang="ts">
import RowTemplate from './RowTemplate.vue';
const years = ['2021', '2022', '2023'];
</script>
<style>
#chart-demo {
height: 440px;
}
.demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th {
font-weight: 400;
width: 200px;
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}
</style>
<template>
<tr class="rows-content">
<th>{{ year }}</th>
<td>
<DxSparkline
:data-source="copperCosts"
:show-min-max="true"
:winloss-threshold="8000"
:value-field="year"
class="sparkline"
argument-field="month"
type="winloss"
>
<DxTooltip :format="{ type: 'currency', precision: 2 }"/>
</DxSparkline>
</td>
<td>
<DxSparkline
:data-source="nickelCosts"
:show-min-max="true"
:show-first-last="false"
:winloss-threshold="19000"
:value-field="year"
class="sparkline"
argument-field="month"
type="winloss"
win-color="#6babac"
loss-color="#8076bb"
>
<DxTooltip :format="{ type: 'currency', precision: 2 }"/>
</DxSparkline>
</td>
<td>
<DxSparkline
:data-source="palladiumCosts"
:winloss-threshold="2000"
:value-field="year"
class="sparkline"
argument-field="month"
type="winloss"
first-last-color="#e55253"
win-color="#7e4452"
loss-color="#ebdd8f"
>
<DxTooltip :format="{ type: 'currency', precision: 2 }"/>
</DxSparkline>
</td>
</tr>
</template>
<script setup lang="ts">
import DxSparkline, {
DxTooltip,
} from 'devextreme-vue/sparkline';
import {
copperCosts,
nickelCosts,
palladiumCosts,
} from './data.ts';
withDefaults(defineProps<{
year?: string
}>(), {
year: '',
});
</script>
<style>
.rows-content td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
.rows-content tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.rows-content td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.rows-content .sparkline {
width: 200px;
height: 30px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const copperCosts = [{
month: 1,
2021: 7970.50,
2022: 9775.93,
2023: 8999.79,
}, {
month: 2,
2021: 8460.25,
2022: 9941.35,
2023: 8955.20,
}, {
month: 3,
2021: 9004.98,
2022: 10237.59,
2023: 8835.72,
}, {
month: 4,
2021: 9335.55,
2022: 10183.13,
2023: 8814.00,
}, {
month: 5,
2021: 10183.97,
2022: 9362.81,
2023: 8234.28,
}, {
month: 6,
2021: 9612.43,
2022: 9033.13,
2023: 8386.23,
}, {
month: 7,
2021: 9433.59,
2022: 7529.79,
2023: 8445.26,
}, {
month: 8,
2021: 9357.19,
2022: 7960.98,
2023: 8351.77,
}, {
month: 9,
2021: 9324.07,
2022: 7734.70,
2023: 8270.86,
}, {
month: 10,
2021: 9778.50,
2022: 7621.21,
2023: 7939.66,
}, {
month: 11,
2021: 9765.48,
2022: 8029.95,
2023: 8173.95,
}, {
month: 12,
2021: 9550.31,
2022: 8367.23,
2023: 8394.11,
}];
export const nickelCosts = [{
month: 1,
2021: 17847.68,
2022: 22355.40,
2023: 28194.61,
}, {
month: 2,
2021: 18595.30,
2022: 24015.55,
2023: 26727.95,
}, {
month: 3,
2021: 16460.83,
2022: 33924.18,
2023: 23288.61,
}, {
month: 4,
2021: 16480.91,
2022: 33132.74,
2023: 23894.56,
}, {
month: 5,
2021: 17552.45,
2022: 28062.55,
2023: 21970.39,
}, {
month: 6,
2021: 17942.32,
2022: 25658.63,
2023: 21233.28,
}, {
month: 7,
2021: 18819.36,
2022: 21481.89,
2023: 21091.26,
}, {
month: 8,
2021: 19160.23,
2022: 22057.39,
2023: 20438.65,
}, {
month: 9,
2021: 19398.23,
2022: 22773.97,
2023: 19644.64,
}, {
month: 10,
2021: 19420.52,
2022: 22032.89,
2023: 18281.23,
}, {
month: 11,
2021: 19970.43,
2022: 25562.70,
2023: 17027.36,
}, {
month: 12,
2021: 20015.55,
2022: 28946.81,
2023: 16460.84,
}];
export const palladiumCosts = [{
month: 1,
2021: 2391.20,
2022: 2030.86,
2023: 1734.27,
}, {
month: 2,
2021: 2342.33,
2022: 2350.10,
2023: 1543.90,
}, {
month: 3,
2021: 2525.61,
2022: 2582.78,
2023: 1426.00,
}, {
month: 4,
2021: 2776.45,
2022: 2330.67,
2023: 1508.00,
}, {
month: 5,
2021: 2900.52,
2022: 2060.05,
2023: 1482.61,
}, {
month: 6,
2021: 2752.48,
2022: 1913.05,
2023: 1348.09,
}, {
month: 7,
2021: 2754.76,
2022: 1973.10,
2023: 1264.48,
}, {
month: 8,
2021: 2544.73,
2022: 2135.52,
2023: 1247.30,
}, {
month: 9,
2021: 2130.32,
2022: 2113.95,
2023: 1239.29,
}, {
month: 10,
2021: 2058.48,
2022: 2078.86,
2023: 1142.09,
}, {
month: 11,
2021: 2036.32,
2022: 1911.55,
2023: 1050.27,
}, {
month: 12,
2021: 1810.52,
2022: 1808.36,
2023: 1087.76,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>